Loading...
Searching...
No Matches
FourthOrderDenseStencil< GridT, IsSafe > Class Template Reference

`#include <openvdb/math/Stencils.h>`

Inheritance diagram for FourthOrderDenseStencil< GridT, IsSafe >:

## Public Types

typedef GridT | GridType
typedef GridT::TreeType | TreeType
typedef GridType::ValueType | ValueType
typedef tree::ValueAccessor< const TreeType, IsSafe > | AccessorType
typedef std::vector< ValueType > | BufferType

## Public Member Functions

| FourthOrderDenseStencil (const GridType &grid)
template<int i, int j, int k>
unsigned int | pos () const
| Return linear offset for the specified stencil point relative to its center.
void | moveTo (const Coord &ijk)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.
const ValueType & | getValue (unsigned int pos=0) const
| Return the value from the stencil buffer with linear offset pos.
void | setValue (const ValueType &value)
| Set the value at the specified location relative to the center of the stencil.
int | size ()
| Return the size of the stencil buffer.
ValueType | median () const
| Return the median value of the current stencil.
ValueType | mean () const
| Return the mean value of the current stencil.
ValueType | min () const
| Return the smallest value in the stencil buffer.
ValueType | max () const
| Return the largest value in the stencil buffer.
const Coord & | getCenterCoord () const
| Return the coordinates of the center point of the stencil.
const ValueType & | getCenterValue () const
| Return the value at the center of the stencil.
bool | intersects (const ValueType &isoValue=zeroVal< ValueType >()) const
| Return true if the center of the stencil intersects the iso-contour specified by the isoValue.
std::bitset< 6 > | intersectionMask (const ValueType &isoValue=zeroVal< ValueType >()) const
| Return true a bit-mask where the 6 bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.
const GridType & | grid () const
| Return a const reference to the grid from which this stencil was constructed.
const AccessorType & | accessor () const
| Return a const reference to the ValueAccessor associated with this Stencil.

## Static Public Attributes

static const int | SIZE = 61

## Protected Attributes

const GridType * | mGrid
Coord | mCenter

## Friends

template<typename, typename, bool>
class | BaseStencil

## Member Typedef Documentation

## AccessorType

typedef tree::ValueAccessor<const TreeType, IsSafe> AccessorType

inherited

## BufferType

typedef std::vector<ValueType> BufferType

inherited

## GridType

template<typename GridT, bool IsSafe = true>

typedef GridT GridType

## TreeType

template<typename GridT, bool IsSafe = true>

typedef GridT::TreeType TreeType

## ValueType

template<typename GridT, bool IsSafe = true>

typedef GridType::ValueType ValueType

## Constructor & Destructor Documentation

## FourthOrderDenseStencil()

template<typename GridT, bool IsSafe = true>

FourthOrderDenseStencil | ( | const GridType & | grid | ) |

inline

## Member Function Documentation

## accessor()

const AccessorType & accessor | ( |  | ) | const

inlineinherited

Return a const reference to the ValueAccessor associated with this Stencil.

## getCenterCoord()

const Coord & getCenterCoord | ( |  | ) | const

inlineinherited

Return the coordinates of the center point of the stencil.

## getCenterValue()

const ValueType & getCenterValue | ( |  | ) | const

inlineinherited

Return the value at the center of the stencil.

## getValue()

const ValueType & getValue | ( | unsigned int | pos = 0 | ) | const

inlineinherited

Return the value from the stencil buffer with linear offset pos.

Note
  The default (pos = 0) corresponds to the first element which is typically the center point of the stencil.

## grid()

const GridType & grid | ( |  | ) | const

inlineinherited

Return a const reference to the grid from which this stencil was constructed.

## intersectionMask()

std::bitset< 6 > intersectionMask | ( | const ValueType & | isoValue = zeroVal<ValueType>() | ) | const

inlineinherited

Return true a bit-mask where the 6 bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.

Note
  There are 2^6 = 64 different possible cases, including no intersections!

The ordering of bit mask is ( -x, +x, -y, +y, -z, +z ), so to check if there is an intersection in -y use mask.test(2) where mask is ther return value from this function. To check if there are any intersections use mask.any(), and for no intersections use mask.none(). To count the number of intersections use mask.count().

## intersects()

bool intersects | ( | const ValueType & | isoValue = zeroVal<ValueType>() | ) | const

inlineinherited

Return true if the center of the stencil intersects the iso-contour specified by the isoValue.

## max()

ValueType max | ( |  | ) | const

inlineinherited

Return the largest value in the stencil buffer.

## mean()

ValueType mean | ( |  | ) | const

inlineinherited

Return the mean value of the current stencil.

## median()

ValueType median | ( |  | ) | const

inlineinherited

Return the median value of the current stencil.

## min()

ValueType min | ( |  | ) | const

inlineinherited

Return the smallest value in the stencil buffer.

## moveTo()

void moveTo | ( | const Coord & | ijk | ) |

inlineinherited

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.

Parameters

  ijk | Index coordinates of stencil center

## pos()

template<typename GridT, bool IsSafe = true>
template<int i, int j, int k>

unsigned int pos | ( |  | ) | const

inline

Return linear offset for the specified stencil point relative to its center.

## setValue()

void setValue | ( | const ValueType & | value | ) |

inlineinherited

Set the value at the specified location relative to the center of the stencil.

## size()

int size | ( |  | ) |

inlineinherited

Return the size of the stencil buffer.

## Friends And Related Symbol Documentation

## BaseStencil

template<typename GridT, bool IsSafe = true>
template<typename, typename, bool>

friend class BaseStencil

friend

## Member Data Documentation

## mCenter

Coord mCenter

protectedinherited

## mGrid

const GridType* mGrid

protectedinherited

## SIZE

template<typename GridT, bool IsSafe = true>

const int SIZE = 61

static